/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-smach-msgs-1.3.1-0raring-20150329-0849/msg/SmachContainerInitialStatusCmd.msg
 *
 */


#ifndef SMACH_MSGS_MESSAGE_SMACHCONTAINERINITIALSTATUSCMD_H
#define SMACH_MSGS_MESSAGE_SMACHCONTAINERINITIALSTATUSCMD_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace smach_msgs
{
template <class ContainerAllocator>
struct SmachContainerInitialStatusCmd_
{
  typedef SmachContainerInitialStatusCmd_<ContainerAllocator> Type;

  SmachContainerInitialStatusCmd_()
    : path()
    , initial_states()
    , local_data()  {
    }
  SmachContainerInitialStatusCmd_(const ContainerAllocator& _alloc)
    : path(_alloc)
    , initial_states(_alloc)
    , local_data(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _path_type;
  _path_type path;

   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _initial_states_type;
  _initial_states_type initial_states;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _local_data_type;
  _local_data_type local_data;




  typedef boost::shared_ptr< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SmachContainerInitialStatusCmd_

typedef ::smach_msgs::SmachContainerInitialStatusCmd_<std::allocator<void> > SmachContainerInitialStatusCmd;

typedef boost::shared_ptr< ::smach_msgs::SmachContainerInitialStatusCmd > SmachContainerInitialStatusCmdPtr;
typedef boost::shared_ptr< ::smach_msgs::SmachContainerInitialStatusCmd const> SmachContainerInitialStatusCmdConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace smach_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'smach_msgs': ['/tmp/buildd/ros-hydro-smach-msgs-1.3.1-0raring-20150329-0849/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> >
{
  static const char* value()
  {
    return "45f8cf31fc29b829db77f23001f788d6";
  }

  static const char* value(const ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x45f8cf31fc29b829ULL;
  static const uint64_t static_value2 = 0xdb77f23001f788d6ULL;
};

template<class ContainerAllocator>
struct DataType< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> >
{
  static const char* value()
  {
    return "smach_msgs/SmachContainerInitialStatusCmd";
  }

  static const char* value(const ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# The path to the node in the server\n\
string path\n\
\n\
# The desired initial state(s)\n\
string[] initial_states\n\
\n\
# Initial values for the local user data of the state machine\n\
# A pickled user data structure\n\
string local_data\n\
";
  }

  static const char* value(const ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.path);
      stream.next(m.initial_states);
      stream.next(m.local_data);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SmachContainerInitialStatusCmd_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::smach_msgs::SmachContainerInitialStatusCmd_<ContainerAllocator>& v)
  {
    s << indent << "path: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.path);
    s << indent << "initial_states[]" << std::endl;
    for (size_t i = 0; i < v.initial_states.size(); ++i)
    {
      s << indent << "  initial_states[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.initial_states[i]);
    }
    s << indent << "local_data: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.local_data);
  }
};

} // namespace message_operations
} // namespace ros

#endif // SMACH_MSGS_MESSAGE_SMACHCONTAINERINITIALSTATUSCMD_H
